import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class Labirinto {

	public Labirinto (int m, int n) {
		lab=new int[m][n];
		int i,j;
		for(i=0; i<m; i++)
			for(j=0; j<n; j++)
				lab[i][j]=0;
		this.m=m;
		this.n=n;
		esistePosizioneCorrente=false;
		disabilitaModifiche=false;
		JFrame frame = new JFrame("Labirinto");
		panel=new LabirintoJPanel();
		frame.setContentPane(panel);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		panel.addMouseListener(new LabirintoMouseAdapter());
		Dimension d=new Dimension(800, 600);
		frame.setSize(d);
		frame.setVisible(true);
		frame.toFront();		
	}
	
	public boolean esplora(int i, int j, int h, int k) {
		impostaPosizioneCorrente(i, j, 250);
		
		if((i<0) || (i>=m) || (j<0) || (j>=n))
			return false;		
		if(lab[i][j] != 0)
			return false;
		if(( i == h) && (j == k))
			return true;
		
		lab[i][j] = 2; // marco come visitato
		
		if(esplora( i, j+ 1, h, k)) { // est
			System.out.println(""+ i+","+( j+ 1));
			return true;
		}
		if(esplora(i-1, j, h, k)) { // nord
			System.out.println(""+( i- 1)+","+ j);
			return true;
		}
		if(esplora(i, j-1, h, k)) { // ovest
			System.out.println(""+ i+","+( j- 1));
			return true;
		}
		if(esplora(i+1, j, h, k)) { // sud
			System.out.println(""+(i+1)+","+ j);
			return true;
		}
		return false;
	}	
		
	public void impostaPosizioneCorrente(int x, int y, int pausa) {
		correnteX=x;
		correnteY=y;
		esistePosizioneCorrente=true;
		panel.repaint();
		try {
			Thread.sleep(pausa);
		} catch(InterruptedException e) {
			System.out.println(""+e);
		}
	}
	
	private void eliminaMarche() {
		int i,j;
		for(i=0; i<m; i++)
			for(j=0; j<n; j++)
				if(lab[i][j]!=1)
					lab[i][j]=0;
	}

	private class LabirintoMouseAdapter extends MouseAdapter {
		public void mousePressed(MouseEvent e) {
			if(!disabilitaModifiche) {
				int x=((e.getX())/w)-1, y=((e.getY())/h)-1;
				if((x>=0)&&(x<n)&&(y>=0)&&(y<m)) {
					lab[y][x]=1-lab[y][x];
					panel.repaint();
				} else {
					disabilitaModifiche=true;
					new LabirintoThread().start();
				}
			}
		}
	}
	
	private class LabirintoJPanel extends JPanel {
		public void paintComponent(Graphics g) {
			int i, j;
			super.paintComponent(g);
			Dimension r=getSize();
			w=r.width/(n+2); h=r.height/(m+2);
			g.clearRect(0, 0, w*(n+2), h*(m+2)); g.setPaintMode(); g.setColor(Color.red);
			//Disegno delle caselle del labirinto
			for(i=0; i<n; i++)
				for(j=0; j<m; j++)
					if(lab[j][i]==1) { g.setColor(Color.red); g.fillRect((i+1)*w, (j+1)*h, w, h); } 
					else if(lab[j][i]==0){g.setColor(Color.white);g.fillRect((i+1)*w,(j+1)*h,w,h);}
					else {	g.setColor(Color.pink);	g.fillRect((i+1)*w, (j+1)*h, w, h);	}
			//Disegno della parete esterna			
			g.setColor(Color.blue);
			g.fillRect(0, 0, w*(n+2), h); g.fillRect(0, (m+1)*h, w*(n+2), h);
			g.fillRect(0, h, w, h*m); g.fillRect((n+1)*w, h, w, h*m);
			//Disegno della griglia			
			g.setColor(Color.black);
			for(i=0; i<=n+2; i++)
				g.drawLine(i*w, 0, i*w, h*(m+2));
			for(j=0; j<=m+2; j++)
				g.drawLine(0, j*h, w*(n+2), j*h);
			//Disegno della posizione attuale			
			if(esistePosizioneCorrente) {
				int raggio=(w<h? w: h)/4;
				g.setColor(Color.green);
				g.fillOval((correnteY+1)*w+w/2-raggio, (correnteX+1)*h+h/2-raggio, 2*raggio, 2*raggio); 
			}
		}		
	}
	
	private class LabirintoThread extends Thread {
		public void run() {
			esplora(0, 0, m-1, n-1);
			eliminaMarche();
			panel.repaint();
			disabilitaModifiche=false;
		}
	}
	
	public static void provaLabirinto() {
		try {
			BufferedReader in=new BufferedReader(new InputStreamReader(System.in));
			int r, c;
			do {
				System.out.print("Numero di righe: ");
				r=Integer.parseInt(in.readLine());
			} while(r<1);
			
			do {
				System.out.print("Numero di colonne: ");
				c=Integer.parseInt(in.readLine());
			} while(c<1);			
			
			System.out.println("Componi il labirinto, poi fai clic sulla parete esterna.");
			
			Labirinto l=new Labirinto(r, c);
		} catch(IOException e) {
			System.out.println("provaLabirinto: ECCEZIONE"+e);
		}
	}
	
	private int[][] lab;
	private int m, n;
	private boolean esistePosizioneCorrente, disabilitaModifiche;
	private int correnteX, correnteY, w, h;
	private LabirintoJPanel panel;
}