/**
 * InseguitoreApplet: applet starting inseguitore game
 * Author: Alessandro Campi 
 */

import java.awt.*;
import java.awt.image.*;
import java.applet.*;
import java.net.*;
import java.util.*;
import java.io.*;

import it.MediaIllusion.Utils.*;
import it.MediaIllusion.Anim.*;


public class InseguitoreApplet extends Applet implements Runnable, TimerInterface {
    boolean invulnerabile=false;
    
    //Strutture dati per i rettangoli
    Vector v1, v2, vettoreRettangoli;
    int numeroRettangoli;
    
    // memory image for double buffering
    Image buffer = null;
    
    // inseguitore
    int xPos;
    int yPos;
    int xAbsPos;
    int yAbsPos;
    boolean mosso=false;
    
    public static final int passo=InseguitoreConst.PASSO;

    // inseguitore direction   0 = sx    1 = dx      2 = up    3 = down
    int dirCandidata = 1,dirReale = 1;
    
    //Nemici
    Nemico nem, nem2;
    
    // inseguitore speed
    private final static long speed = InseguitoreConst.SPEED;   // as milliseconds between frames
    private final static long accelerazione = InseguitoreConst.ACCELERAZIONE;
    private final static long attesa = InseguitoreConst.ATTESA;
    // time to wait before starting... countdown
    long timeWait = 4;
    
    boolean mappaCorrente[][];
    boolean mappaPercorsi[][];
    
    private final static int distanzaQuadrata=36;

    // score
    int score = 0; 
    
    //numFrutti
    int numPezzi=0;
    int numTotalePezzi=0;
    
    private static final int map[][][] = {
        InseguitoreConst.map[0],
        InseguitoreConst.map[1],
        InseguitoreConst.map[2],
        InseguitoreConst.map[3],
        InseguitoreConst.map[4],
        InseguitoreConst.map[5],
        InseguitoreConst.map[6],
        InseguitoreConst.map[7],
        InseguitoreConst2.map[0],
        InseguitoreConst2.map[1]
    };
    
    //livello
    int livello=0;
    private static final int maxLivelli=map.length;
    
    //lives
    int lives=InseguitoreConst.NUM_VITE;

    // images used for rendering
    Image background;
    Image blank;
    Image gamestart;
    Image gameover;
    
    Image inseguitore;

    Image nemico;
    
    Image sfondoLivello[];
    Image sfondoLivelloScuro[];
    
    // Thread used for controlling image downloading
    Thread myThread = null;
    
    // flag indicating full downloading
    boolean okDownloaded = false;
    
    // downloading status
    int downloadingStatus = 0;
	
    // flag indicating if user is playing (game started)
    // gameStarted = 0 --> not pressed start
    // gameStarted = 1 --> start pressed
    // gameStarted = 2 --> game started
    int gameStarted = 0;
    
    boolean firstMatch=true, vediPressPlay=true, vediRecord=false;
    
    // Timer
    it.MediaIllusion.Anim.Timer t = null;
    
    // flag indicating that inseguitore is alive
    boolean alive = false, deading = false;
    
    // flag indicating that the help window is active
    boolean help = false;
    
    // flag indicating that the credit window is active
    boolean credits = false;
    
    //collegamento con asp
    String username, pwd=new String("abc");
    int classPosition;
    boolean saved;
    
    //lingua
    String version;
    
    //variabili utili per il disegno
    Image offScreenImage = null;
    Graphics offScreenGraphic = null;
    
    private static final int width=480;
    private static final int height=390;
    private static final int xBackground=0;
    private static final int yBackground=height;
    private static final int xSfondoLivelloNormale=xBackground;
    private static final int ySfondoLivelloNormale=yBackground+height;
    private static final int xSfondoLivelloScuro=xBackground;
    private static final int ySfondoLivelloScuro=ySfondoLivelloNormale+(InseguitoreConst.MAP_ROWS-2)*InseguitoreConst.MAP_CELL_DIMENSION;
    private static final int mezzaCella=InseguitoreConst.MAP_CELL_DIMENSION/2;
    private static final int xBackgroundConOffset=xBackground+InseguitoreConst.OFFSET_X;
    private static final int yBackgroundConOffset=yBackground+InseguitoreConst.OFFSET_Y;
    
    //costanti precalcolate per rendere il codice pi efficiente
    int xp=1;
    int yp=1;
    int xr=xBackgroundConOffset+xp*InseguitoreConst.MAP_CELL_DIMENSION;
    int xrm=xr+mezzaCella;
    int xrt=xr+InseguitoreConst.MAP_CELL_DIMENSION;
    int yr=yBackgroundConOffset+yp*InseguitoreConst.MAP_CELL_DIMENSION;
    int yrm=yr+mezzaCella;
    int yrt=yr+InseguitoreConst.MAP_CELL_DIMENSION;

    Color bianco;
    Color rosso;
    Color giallo;
    Color nero;

    FiltraImmagine f;
    
    //stringhe
    String downloadingString=new String();
    String goal=new String();
    String donthit=new String();
    String legend=new String();
    String tu=new String();
    String enemy=new String();
    String vitaNuovaString=new String();
    String congratulazioni=new String();
    String rank=new String();
    String sorry=new String();    
    String livelloString=new String();
    
    /**
    * init
    */
    public void init() {     
        v1=new Vector(); v2=new Vector();
        
        f=new FiltraImmagine();

        username=new String(); username=getParameter("username");
        
        inserisciStringhe("it");
        
        bianco=new Color(255,255,255);
        giallo=new Color(0,255,255);
        rosso=new Color(255,0,0);
        nero=new Color(0,0,0);
        
        nem=new Nemico(37,37);
        nem2=new Nemico(1,37);
        
        preparaBuffer();
        
        mappaCorrente=new boolean[InseguitoreConst.MAP_ROWS][InseguitoreConst.MAP_COLOUMNS];
        mappaPercorsi=new boolean[InseguitoreConst.MAP_ROWS][InseguitoreConst.MAP_COLOUMNS];
        
        sfondoLivello=new Image[map.length];
        sfondoLivelloScuro=new Image[map.length];

        myThread = new Thread(this);
        myThread.start();        
    } // end init
    
    private void inserisciStringhe(String lingua)
    {
        if(lingua.equalsIgnoreCase("it"))
        {            
            //scritte in italiano
            downloadingString="Caricamento immagini in corso... attendere";
            goal="Il tuo obiettivo: completare la griglia";
            donthit="Non toccare l'inseguitore";
            legend="Legenda: ";
            tu="Tu";
            enemy="Nemico";
            vitaNuovaString="Ogni "+(map.length/2)+" livelli vinci una vita se ne hai gi perso una";
            congratulazioni="Congratulazioni! Questo  il tuo nuovo record";
            rank="La tua posizione : ";
            sorry="Spiacente, non hai migliorato il tuo record";
            livelloString="Livello: ";
        }
        else
        {
            //scritte in inglese
            downloadingString="Downloading images and map info... wait";
            goal="Your goal: complete the grid.";
            donthit="Don't hit the hunter";
            legend="Legend: ";
            tu="You";
            enemy="Enemy";
            vitaNuovaString="Every "+(map.length/2)+" levels you win a life if you had lost one";
            congratulazioni="Congratulations! This is your new record";
            rank="New rank position is: ";
            sorry="Sorry, you haven't improved your record";
            livelloString="Level: ";
        }
    }
    
    /*
     *preparaBuffer
     */
    protected void preparaBuffer()
    {
        // buffer for double buffering
        Dimension d = size();//size() restituisce le dimensioni dell'applet fissate nell'HTML

        offScreenImage = createImage(width,height*5);
        offScreenGraphic = offScreenImage.getGraphics();
    }//preparaBuffer

    /**                                       
    * setDownloadingStatus
    */
    public void setDownloadingStatus(int status) 
    {
        downloadingStatus = status;
        repaint();
    }
    
    /**
    * run
    */
    public void run() 
    {
        setDownloadingStatus(1);
        
        caricaImmaginiComuni();
        
        okDownloaded = true;
        
        t = new it.MediaIllusion.Anim.Timer(attesa,this);  
        
        setDownloadingStatus(2);
        
        repaint();
        
        t.start();
        t.setInterval(500);
    }//run

    /**
    * caricaImmaginiComuni
    */
    protected void caricaImmaginiComuni() {
        MediaTracker tracker = new MediaTracker(this);
        background = getImage(getCodeBase(),"applet.jpg");
        tracker.addImage(background,1);
        inseguitore = getImage(getCodeBase(),"inseguitore.gif");
        tracker.addImage(inseguitore,2);                       
        nemico = getImage(getCodeBase(),"nemico.gif");
        tracker.addImage(nemico,3);
        blank = getImage(getCodeBase(),"blank.gif");
        tracker.addImage(blank,4);
        gamestart = getImage(getCodeBase(),"gamestart.gif");
        tracker.addImage(gamestart,5);
        gameover = getImage(getCodeBase(),"gameover.gif");
        tracker.addImage(gameover,6);
        /*
        sfondoLivello[0] = getImage(getCodeBase(),"livello1.jpg");
        tracker.addImage(sfondoLivello[0],6);//*/
        
        boolean finished = false;
        while (!finished) 
        {            
            finished = tracker.checkAll(true);
            if (finished) break;
            try 
            {
                Thread.sleep(50);
            } catch(Exception e) {}
        }

        //disegno del background
        offScreenGraphic.drawImage(background,0,yBackground,this);
        offScreenGraphic.copyArea(xBackground,yBackground,width,height,0,-yBackground);
        
        caricaImmaginiLivello(1);
    }

    /**
    * caricaImmaginiLivello
    */
    protected void caricaImmaginiLivello(int l) {
        String livelloDaCaricare="livello"+l+".jpg";
        
        boolean finished = false;
        MediaTracker tracker = new MediaTracker(this);
        
        // read images
        if(sfondoLivello[l-1]==null) {
            //tracker = new MediaTracker(this);
            sfondoLivello[l-1] = getImage(getCodeBase(),livelloDaCaricare);
            tracker.addImage(sfondoLivello[l-1],1);
        } else {
            finished=true;
        }
        
        while (!finished) {            
            finished = tracker.checkAll(true);
            if (finished) break;
            try  {
                Thread.sleep(50);
            } catch(Exception e) {System.out.println(e);}
        }       
        
        finished=false;
        
        if(sfondoLivelloScuro[l-1]==null) {
            tracker = new MediaTracker(this);
            sfondoLivelloScuro[l-1]=f.filter(this,sfondoLivello[l-1]);
            tracker.addImage(sfondoLivelloScuro[l-1],1);
        } else { finished = true; }
        
        while (!finished) {            
            finished = tracker.checkAll(true);
            if (finished) break;
            try {
                Thread.sleep(50);
            } catch(Exception e) {System.out.println(e);}
        }
        
        offScreenGraphic.drawImage(sfondoLivello[l-1],xSfondoLivelloNormale,ySfondoLivelloNormale,null);
        offScreenGraphic.drawImage(sfondoLivelloScuro[l-1],xSfondoLivelloScuro,ySfondoLivelloScuro,null);        
    }        
    
    /**
    * mouseDown
    */
    public boolean mouseDown(Event evtObj, int x, int y) {
        if (!alive) {
            if (x > InseguitoreConst.START_X1 && x < InseguitoreConst.START_X2) {
                if (y > InseguitoreConst.START_Y1 && y < InseguitoreConst.START_Y2) {
                    help=false;
                    cominciaPartita();
                    return true;
                }
            }            
            if (x > InseguitoreConst.HELP_X1 && x < InseguitoreConst.HELP_X2) {
                if (y > InseguitoreConst.HELP_Y1 && y < InseguitoreConst.HELP_Y2) {
                    help = true;
                    repaint();
                }
            }            
            if (x > InseguitoreConst.CREDITS_X1 && x < InseguitoreConst.CREDITS_X2) {
                if (y > InseguitoreConst.CREDITS_Y1 && y < InseguitoreConst.CREDITS_Y2) {
                    try {
                        AppletContext ac = getAppletContext();	
                        String host = getCodeBase().getHost();
                        ac.showDocument(new URL("http://"+host+"/giochi/credits/credits.html"),"Credits games");
                    } catch(Exception e) { System.out.println("eccezione: " + e + "\n"); }
                }
            }            
            if (x > InseguitoreConst.CLASS_X1 && x < InseguitoreConst.CLASS_X2) {
                if (y > InseguitoreConst.CLASS_Y1 && y < InseguitoreConst.CLASS_Y2) {
                    try {
                        AppletContext ac = getAppletContext();	
                        String host = getCodeBase().getHost();
                        String uname = replace(username," ","%20");        	
                        ac.showDocument(new URL("http://"+host+"/cgi-bin/ClassFollower.asp?username="+uname),"Follower Classifies");
                    }
                    catch(Exception e) 
                    {
                        System.out.println("eccezione: " + e +"\n");
                    }
                }
            }
                
            else
                repaint();
        }     

        return false;
    }
    
    /**
    * cominciaPartita
    */
    protected void cominciaPartita()
    {
        alive=true;
        livello=0;
        lives=InseguitoreConst.NUM_VITE;

        score=0;
        cambiaLivello();
    }//cominciaPartita

    /**
    * cambiaLivello
    */
    protected void cambiaLivello() {
        try {
            livello++;
            
            setDownloadingStatus(1);
            
            if((livello!=1)||!firstMatch)
                caricaImmaginiLivello(((livello-1)%maxLivelli)+1);
            
            //codice da rimuovere se rivogliono che si riparta con vuoto
            v1=new Vector(); v2=new Vector();
            vettoreRettangoli=new Vector();
            
            //System.out.println("mappa = "+(livello%maxLivelli-1));
            offScreenGraphic.drawImage(background,xBackground,yBackground,null);

            pulisciSfondo();

            //disegno degli sfondi
            offScreenGraphic.copyArea(xSfondoLivelloNormale,ySfondoLivelloNormale,(InseguitoreConst.MAP_COLOUMNS-2)*InseguitoreConst.MAP_CELL_DIMENSION,(InseguitoreConst.MAP_ROWS-2)*InseguitoreConst.MAP_CELL_DIMENSION,InseguitoreConst.OFFSET_X-xSfondoLivelloNormale+xBackground+InseguitoreConst.MAP_CELL_DIMENSION,InseguitoreConst.OFFSET_Y-ySfondoLivelloNormale+yBackground+InseguitoreConst.MAP_CELL_DIMENSION);
            
            parseMap(map[((livello-1)%maxLivelli)]);

            creaRettangoli();                        
            
            caricaImmaginiRettangoli();

            //fine codice da rimuovere

            iniziaLivelloComuni();
            
            //offScreenGraphic.setColor(nero);

            //Ogni mezzo numero totale livelli se ho gi perso una vita ne vinco una
            if(livello%(map.length/2)==0)
            {
                if(lives<InseguitoreConst.NUM_VITE)
                    lives++;
            }
            
            setDownloadingStatus(2);
            
            t.setInterval(attesa);
            timeWait = 2;      	      	      	
            gameStarted = 1;
        }
        catch(Exception e)
        {
            System.out.println(""+e+" livello = "+livello);
        }
    }    
    
    /*
     *iniziaLivelloComuni
     */
    protected void iniziaLivelloComuni()
    {
        try
        {
            /*
            v1=new Vector();
            v2=new Vector();
            vettoreRettangoli=new Vector();
            
            //System.out.println("mappa = "+(livello%maxLivelli-1));
            offScreenGraphic.drawImage(background,xBackground,yBackground,null);

            // display lives
            for(int u=0;u<lives-1;u++)
            {
                offScreenGraphic.drawImage(inseguitore,xBackground+InseguitoreConst.LIFE_X,yBackground+InseguitoreConst.LIFE_Y+(InseguitoreConst.MAP_CELL_DIMENSION+10)*u,null);
            }
            
            pulisciSfondo();

            //disegno degli sfondi
            offScreenGraphic.copyArea(xSfondoLivelloNormale,ySfondoLivelloNormale,(InseguitoreConst.MAP_COLOUMNS-2)*InseguitoreConst.MAP_CELL_DIMENSION,(InseguitoreConst.MAP_ROWS-2)*InseguitoreConst.MAP_CELL_DIMENSION,InseguitoreConst.OFFSET_X-xSfondoLivelloNormale+xBackground+InseguitoreConst.MAP_CELL_DIMENSION,InseguitoreConst.OFFSET_Y-ySfondoLivelloNormale+yBackground+InseguitoreConst.MAP_CELL_DIMENSION);
            
            parseMap(InseguitoreConst.map[((livello-1)%maxLivelli)]);

            creaRettangoli();                        
            
            caricaImmaginiRettangoli();
            //*/
            
            offScreenGraphic.copyArea(xBackground,yBackground,width,height,0,-yBackground);
            
            // display lives
            for(int u=0;u<lives-1;u++)
            {
                offScreenGraphic.drawImage(inseguitore,InseguitoreConst.LIFE_X,InseguitoreConst.LIFE_Y+(InseguitoreConst.MAP_CELL_DIMENSION*2+10)*u,null);
            }            
            
            offScreenGraphic.setColor(bianco);
            offScreenGraphic.setFont(new Font("Arial",Font.PLAIN,11));
            offScreenGraphic.drawString(livelloString+(livello),InseguitoreConst.LEVEL_X,InseguitoreConst.LEVEL_Y);    	            
            offScreenGraphic.setColor(nero);
            
            inizializzaPosizioneInseguitore();
            nem.inizializzaPosizioneNemico();
            if(livello>maxLivelli)
            {
                nem2.inizializzaPosizioneNemico();
            }
        }
        catch(Exception e)
        {
            System.out.println(""+e);
        }
    }        
    
    /*
     *caricaImmaginiRettangoli
     */
    protected void caricaImmaginiRettangoli()
    {
        for(Enumeration e=vettoreRettangoli.elements();e.hasMoreElements();)
        {
            Rettangolo r=(Rettangolo)e.nextElement();
            offScreenGraphic.copyArea(r.x1RealeScuro,r.y1RealeScuro,r.w,r.h,r.saltoScuroX,r.saltoScuroY);
        }
    }//caricaImmaginiRettangoli

    /*
     *creaRettangoli
     */
    protected void creaRettangoli()
    {
        try
        {
            Enumeration e2=v2.elements();
            for(Enumeration e1=v1.elements();e1.hasMoreElements();)
            {
                Pos p1=(Pos)e1.nextElement();
                Pos p2=(Pos)e2.nextElement();
                Rettangolo r=new Rettangolo(p1.x,p1.y,p2.x,p2.y,xSfondoLivelloNormale,ySfondoLivelloNormale,xSfondoLivelloScuro,ySfondoLivelloScuro,xBackground,yBackground);
                vettoreRettangoli.addElement(r);
                //System.out.println("x="+p1.x+" y="+p1.y+" x="+p2.x+" y="+p2.y);
                //System.out.println("Rettangolo: "+r.getX1()+" "+r.getY1()+" "+r.getX2()+" "+r.getY2()+" ");
            }
            
            numeroRettangoli=0;
            for(Enumeration e=vettoreRettangoli.elements();e.hasMoreElements();)
            {
                numeroRettangoli++;
                Rettangolo r=(Rettangolo)e.nextElement();
                for(int x=1;x<InseguitoreConst.MAP_COLOUMNS-1;x++)
                {
                    for(int y=1;y<InseguitoreConst.MAP_ROWS-1;y++)
                    {
                        if(!mappaPercorsi[y][x])
                        {
                            if(r.isIn(x,y))
                            {
                                r.incrementaTotale();
                            }
                        }
                    }
                }
            }//*/
        }
        catch(Exception e)
        {
            System.out.println(""+e);
        }
    }//creaRettangoli
    
    /*
     *pulisciSfondo
     */
    protected void pulisciSfondo()
    {
        offScreenGraphic.setColor(nero);
        
        for (int i = 2; i < InseguitoreConst.MAP_ROWS-1; i++) 
        {
            for (int j = 1; j < InseguitoreConst.MAP_COLOUMNS-1; j++) 
            {
                offScreenGraphic.drawLine(xBackgroundConOffset+j*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella,
                                            yBackgroundConOffset+i*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella,
                                            xBackgroundConOffset+(j)*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella,
                                            yBackgroundConOffset+(i-1)*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella);
                offScreenGraphic.drawLine(xBackgroundConOffset+j*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella,
                                            yBackgroundConOffset+i*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella,
                                            xBackgroundConOffset+(j-1)*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella,
                                            yBackgroundConOffset+(i)*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella);
            }
        }
    }
    
    /*
     *inizializzaPosizioneInseguitore
     */
    protected void inizializzaPosizioneInseguitore()
    {
        xPos=1;
        yPos=1;
        xAbsPos=xPos*InseguitoreConst.MAP_CELL_DIMENSION;
        yAbsPos=yPos*InseguitoreConst.MAP_CELL_DIMENSION;
        dirCandidata=1;
        dirReale=1;
        
        testPoint();//serve a non lasciare il buco alla partenza
    }//inizializzaPosizioneInseguitore
        
    /**
    * keyDown
    */
    public boolean keyDown(Event evt, int key) 
    {   
        if (alive) {
            if (key == 1004) {
                // up
                dirCandidata = 2;
            } else if (key == 1005) {
                // down
                dirCandidata = 3;
            } else if (key == 1006) {        
                // left
                dirCandidata = 0;
            } else if (key == 1007) {
                // right
                dirCandidata = 1;
            } else if(key==101) { //e
                invulnerabile=!invulnerabile;
            }
        }
        
        return false;
    }
   
    /**
    * parseMap
    */
    public void parseMap(int map[][]) {
        numTotalePezzi=0; numPezzi=0;

        offScreenGraphic.setColor(bianco);//era giallo
        
        for (int i = 0; i < InseguitoreConst.MAP_ROWS; i++) {
            for (int j = 0; j < InseguitoreConst.MAP_COLOUMNS; j++) {
                if(map[i][j]==1) {
                    mappaCorrente[i][j]=true;
                    mappaPercorsi[i][j]=false;
                    numTotalePezzi++;
                    if(map[i-1][j]==1) {
                        offScreenGraphic.drawLine(xBackgroundConOffset+j*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella,
                                                    yBackgroundConOffset+i*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella,
                                                    xBackgroundConOffset+(j)*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella,
                                                    yBackgroundConOffset+(i-1)*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella);
                    }
                    if(map[i][j-1]==1) {
                        offScreenGraphic.drawLine(xBackgroundConOffset+j*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella,
                                                    yBackgroundConOffset+i*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella,
                                                    xBackgroundConOffset+(j-1)*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella,
                                                    yBackgroundConOffset+(i)*InseguitoreConst.MAP_CELL_DIMENSION+mezzaCella);
                    }
                    
                    //costruzione rettangoli
                    if((map[i][j+1]==1)&&(map[i+1][j]==1)) {
                        Pos p=new Pos(j,i);
                        v1.addElement(p);
                        int l=j+1;
                        for(int k=i+1;k<InseguitoreConst.MAP_COLOUMNS-1;k++) {
                            if(map[k][l]==1) {
                                if((map[k-1][l]==1)&&(map[k][l-1]==1)) {
                                    v2.addElement(new Pos(l,k));
                                    break;
                                } else if(map[k-1][l]==1) {
                                    l--;
                                } else if(map[k][l-1]==1) {
                                    k--;
                                }
                            }
                            
                            l++;
                        }
                    }
                } else {
                    mappaCorrente[i][j]=false;
                    mappaPercorsi[i][j]=true;
                }
            }
        }
    } // end parseMap
    
    /**
    * update
    */
    public void update(Graphics g) {
        paint(g); 
    }
    
    /**
    * paint
    */
    public void paint(Graphics g) {    	
    	try {
            if (downloadingStatus == 1) {
                Dimension d = getSize();
                g.setColor(new Color(0,0,0));
                g.fillRect(0,0,d.width,d.height);
                g.setColor(new Color(200,200,0));
                g.drawString(downloadingString,130,140);
            } else if (downloadingStatus == 2) { 
                //debug = 1;
                
                //TENTATIVO DI ELIMINARE UN BACO MOLTO BRUTTO
                //coloritura griglie
                offScreenGraphic.setColor(rosso);
        
                if(mappaCorrente[yp-1][xp])
                    offScreenGraphic.drawLine(xrm,yrm,xrm,yr);
                if(mappaCorrente[yp+1][xp])
                    offScreenGraphic.drawLine(xrm,yrm,xrm,yrt);
                if(mappaCorrente[yp][xp-1])
                    offScreenGraphic.drawLine(xrm,yrm,xr,yrm);
                if(mappaCorrente[yp][xp+1])
                    offScreenGraphic.drawLine(xrm,yrm,xrt,yrm);


                //disegno del background solo dove serve
                /*
                //versione originale
                offScreenGraphic.copyArea(xBackgroundConOffset+xAbsPos-5,yBackgroundConOffset+yAbsPos-5,26,26,0,-yBackground);
                offScreenGraphic.copyArea(xBackgroundConOffset+nem.xAbsPosNemico-5,yBackgroundConOffset+nem.yAbsPosNemico-5,26,26,0,-yBackground);
                if(livello>maxLivelli)
                {
                    offScreenGraphic.copyArea(xBackgroundConOffset+nem2.xAbsPosNemico-5,yBackgroundConOffset+nem2.yAbsPosNemico-5,26,26,0,-yBackground);
                }
                offScreenGraphic.copyArea(xBackground+InseguitoreConst.SCORE_X,yBackground+InseguitoreConst.SCORE_Y-10,30,10,0,-yBackground);
               //*/

                /*
                //versione originale allargata
                offScreenGraphic.copyArea(xBackgroundConOffset+xAbsPos-10,yBackgroundConOffset+yAbsPos-10,36,36,0,-yBackground);
                offScreenGraphic.copyArea(xBackgroundConOffset+nem.xAbsPosNemico-10,yBackgroundConOffset+nem.yAbsPosNemico-10,36,36,0,-yBackground);
                if(livello>maxLivelli)
                {
                    offScreenGraphic.copyArea(xBackgroundConOffset+nem2.xAbsPosNemico-10,yBackgroundConOffset+nem2.yAbsPosNemico-10,36,36,0,-yBackground);
                }
                offScreenGraphic.copyArea(xBackground+InseguitoreConst.SCORE_X,yBackground+InseguitoreConst.SCORE_Y-10,30,10,0,-yBackground);
               //*/
                
                /*
                //versione larga
                offScreenGraphic.copyArea(xBackgroundConOffset+xAbsPos-15,yBackgroundConOffset+yAbsPos-15,46,46,0,-yBackground);
                offScreenGraphic.copyArea(xBackgroundConOffset+nem.xAbsPosNemico-15,yBackgroundConOffset+nem.yAbsPosNemico-15,46,46,0,-yBackground);
                if(livello>maxLivelli)
                {
                    offScreenGraphic.copyArea(xBackgroundConOffset+nem2.xAbsPosNemico-15,yBackgroundConOffset+nem2.yAbsPosNemico-15,46,46,0,-yBackground);
                }
                offScreenGraphic.copyArea(xBackground+InseguitoreConst.SCORE_X,yBackground+InseguitoreConst.SCORE_Y-10,30,10,0,-yBackground);
               //*/
                
                //*
                //versione tutta l'area di gioco
                offScreenGraphic.copyArea(xBackgroundConOffset,yBackgroundConOffset,312,312,0,-yBackground);
                offScreenGraphic.copyArea(xBackground+InseguitoreConst.SCORE_X,yBackground+InseguitoreConst.SCORE_Y-10,30,10,0,-yBackground);
               //*/
                
                /*
                //versione a strisce
                offScreenGraphic.copyArea(xBackgroundConOffset,yBackgroundConOffset+yAbsPos-5,312,26,0,-yBackground);
                offScreenGraphic.copyArea(xBackgroundConOffset+xAbsPos-5,yBackgroundConOffset,26,312,0,-yBackground);
                
                offScreenGraphic.copyArea(xBackgroundConOffset,yBackgroundConOffset+nem.yAbsPosNemico-5,312,26,0,-yBackground);
                offScreenGraphic.copyArea(xBackgroundConOffset+nem.xAbsPosNemico-5,yBackgroundConOffset,26,312,0,-yBackground);
                
                if(livello>maxLivelli)
                {
                    offScreenGraphic.copyArea(xBackgroundConOffset,yBackgroundConOffset+nem2.yAbsPosNemico-5,312,26,0,-yBackground);
                    offScreenGraphic.copyArea(xBackgroundConOffset+nem2.xAbsPosNemico-4,yBackgroundConOffset,26,312,0,-yBackground);
                }
                offScreenGraphic.copyArea(xBackground+InseguitoreConst.SCORE_X,yBackground+InseguitoreConst.SCORE_Y-10,30,10,0,-yBackground);
               //*/
                
                if (help) 
                {
                    //HELP
                    offScreenGraphic.drawImage(blank,InseguitoreConst.OFFSET_X+InseguitoreConst.MAP_CELL_DIMENSION,InseguitoreConst.OFFSET_Y+InseguitoreConst.MAP_CELL_DIMENSION,null);
                    
                    offScreenGraphic.setFont(new Font("Helvetica",Font.BOLD,14));
                    offScreenGraphic.setColor(bianco);
                    offScreenGraphic.drawString("Follower Help",180,60);
                    
                    offScreenGraphic.setFont(new Font("Helvetica",Font.PLAIN,12));
                    offScreenGraphic.drawString(goal,80,80);
                    offScreenGraphic.drawString(donthit,80,100);
                    offScreenGraphic.drawString(legend,80,120);
                    offScreenGraphic.drawImage(inseguitore,80,130,null);
                    offScreenGraphic.drawString(tu,102,142);
                    offScreenGraphic.drawImage(nemico,80,150,null);
                    offScreenGraphic.drawString(enemy,102,162);
                    
                    offScreenGraphic.drawString(vitaNuovaString,80,284);                    
                }
                else
                {
                    if(alive)
                    {
                        //disegnaInseguitore
                        offScreenGraphic.drawImage(inseguitore,InseguitoreConst.OFFSET_X+xAbsPos,InseguitoreConst.OFFSET_Y+yAbsPos,null);
                        
                        //disegnaNemici
                        offScreenGraphic.drawImage(nemico,InseguitoreConst.OFFSET_X+nem.xAbsPosNemico,InseguitoreConst.OFFSET_Y+nem.yAbsPosNemico,null);
                        if(livello>maxLivelli)
                        {
                            offScreenGraphic.drawImage(nemico,InseguitoreConst.OFFSET_X+nem2.xAbsPosNemico,InseguitoreConst.OFFSET_Y+nem2.yAbsPosNemico,null);
                        }
                    }
                    else
                    {
                        offScreenGraphic.drawImage(blank,InseguitoreConst.OFFSET_X+InseguitoreConst.MAP_CELL_DIMENSION,InseguitoreConst.OFFSET_Y+InseguitoreConst.MAP_CELL_DIMENSION,null);

                        if(firstMatch)
                        {
                            if(vediPressPlay)
                            {
                                //debug = 6;
                                offScreenGraphic.drawImage(gamestart,InseguitoreConst.GAMEOVER_X,InseguitoreConst.GAMEOVER_Y+100,null);                        	
                                //debug = 7;
                                vediPressPlay=false;
                            }
                            else
                            {
                                vediPressPlay=true;
                            }
                        }
                        else
                        {
                            //debug = 8;
                            
                            offScreenGraphic.drawImage(gameover,InseguitoreConst.GAMEOVER_X,InseguitoreConst.GAMEOVER_Y,null);
                            //debug = 9;
                            if(vediPressPlay)
                            {
                                offScreenGraphic.drawImage(gamestart,InseguitoreConst.GAMEOVER_X,InseguitoreConst.GAMEOVER_Y+100,null);
                                vediPressPlay=false;
                            }
                            else
                            {
                                vediPressPlay=true;
                            }
                            
                            offScreenGraphic.setFont(new Font("Arial",Font.PLAIN,11));
                            offScreenGraphic.setColor(bianco);
                            
                            if(saved)
                            {
                                if(vediRecord)
                                {
                                    offScreenGraphic.drawString(congratulazioni,InseguitoreConst.GAMEOVER_X-40,InseguitoreConst.GAMEOVER_Y+50);
                                    offScreenGraphic.drawString(rank+classPosition,InseguitoreConst.GAMEOVER_X-2,InseguitoreConst.GAMEOVER_Y+70);
                                }
                            }
                            else
                            {
                                if(vediRecord)
                                {
                                    offScreenGraphic.drawString(sorry,InseguitoreConst.GAMEOVER_X-38,InseguitoreConst.GAMEOVER_Y+50);
                                }
                            }
                        }                            
                    }
                }
                
                // display score
                offScreenGraphic.setColor(bianco);
                //offScreenGraphic.setFont(new Font("Arial",Font.PLAIN,11));
                offScreenGraphic.drawString(""+score,InseguitoreConst.SCORE_X,InseguitoreConst.SCORE_Y);    	
                
                //DISEGNA COORDINATE, UTILE PER DEBUGGING
                //g.drawString(""+xPos+","+yPos,InseguitoreConst.SCORE_X,InseguitoreConst.SCORE_Y+20);
                //g.drawString(""+username,InseguitoreConst.SCORE_X,InseguitoreConst.SCORE_Y+20);
                //g.drawString(""+downloadingStatus,InseguitoreConst.SCORE_X,InseguitoreConst.SCORE_Y+30);
                //g.drawString(""+help,InseguitoreConst.SCORE_X,InseguitoreConst.SCORE_Y+40);

                g.drawImage(offScreenImage,0,0,this);
            }
        }
        catch(Exception e) 
        {
            System.out.println("e"+e);
        }
    } // end paint

    /**
    * tick
    */
    public void tick() {
        if(gameStarted==2) {
            //System.out.println("inizioTick gameStarted=2");
            updateInseguitore();
            
            //muovi inseguitore
            if(mosso) {
                switch(dirReale) {
                    case 0: xAbsPos-=passo; break;
                    case 1: xAbsPos+=passo; break;
                    case 2: yAbsPos-=passo; break;
                    case 3: yAbsPos+=passo; break;
                }        
            }
            
            nem.updateNemico(mappaCorrente,xAbsPos,yAbsPos,dirCandidata);
            nem.muoviNemico();
            if(livello>maxLivelli) {
                nem2.updateNemico(mappaCorrente,xAbsPos,yAbsPos,dirCandidata);
                nem2.muoviNemico();
            }
            
            testPoint();
            
            if(invulnerabile) {}
            else { 
            	if(nem.checkNemico(xAbsPos,yAbsPos)) {
            		InseguitoreDead();                
            	}
                if(livello>maxLivelli) {
                    if(nem2.checkNemico(xAbsPos,yAbsPos)) {
                        InseguitoreDead();
                    }
                }
            }
        }
        else if (gameStarted == 1)
        {
            //System.out.println("inizioTick gameStarted=1");
            timeWait--;
            if (timeWait == 0)
            { 
                gameStarted = 2;
                if(livello>maxLivelli)
                    t.setInterval(speed-accelerazione);
                else
                    t.setInterval(speed);
            }
        }
        
        repaint();
    }//tick
            
    /**   
    * testPoint
    */
    private final void testPoint() 
    {
        int x=xAbsPos;
        int y=yAbsPos;
                
        switch(dirReale)
        {
            case 0: x=x+mezzaCella; break;
            case 1: x=x+mezzaCella; break;
            case 2: y=y+mezzaCella; break;
            case 3: y=y+mezzaCella; break;
        }
                
        int xa=x/InseguitoreConst.MAP_CELL_DIMENSION;
        int ya=y/InseguitoreConst.MAP_CELL_DIMENSION;
        
        //QUI INSERIRE CONTROLLO PUNTO
        if(mappaPercorsi[ya][xa])
        {}
        else
        {
            xp=xa;
            yp=ya;
            //costanti precalcolate per rendere il codice pi efficiente
            xr=xBackgroundConOffset+xa*InseguitoreConst.MAP_CELL_DIMENSION;
            xrm=xr+mezzaCella;
            xrt=xr+InseguitoreConst.MAP_CELL_DIMENSION;
            yr=yBackgroundConOffset+ya*InseguitoreConst.MAP_CELL_DIMENSION;
            yrm=yr+mezzaCella;
            yrt=yr+InseguitoreConst.MAP_CELL_DIMENSION;

            //*
            //coloritura griglie
            offScreenGraphic.setColor(rosso);        
            if(mappaCorrente[yp-1][xp])
                offScreenGraphic.drawLine(xrm,yrm,xrm,yr);
            if(mappaCorrente[yp+1][xp])
                offScreenGraphic.drawLine(xrm,yrm,xrm,yrt);
            if(mappaCorrente[yp][xp-1])
                offScreenGraphic.drawLine(xrm,yrm,xr,yrm);
            if(mappaCorrente[yp][xp+1])
                offScreenGraphic.drawLine(xrm,yrm,xrt,yrm);

            mappaPercorsi[ya][xa]=true;
            
            for(int i=numeroRettangoli-1;i>=0;i--)    
            {
                Rettangolo r=(Rettangolo)vettoreRettangoli.elementAt(i);
                if(r.isIn(xa,ya))
                {
                    r.incrementaVisitati();
                    if(r.controllaCompleto())
                    {
                        offScreenGraphic.copyArea(r.x1RealeNormale,r.y1RealeNormale,r.w,r.h,r.saltoNormaleDirettoX,r.saltoNormaleDirettoY);
                        offScreenGraphic.copyArea(r.x1RealeNormale,r.y1RealeNormale,r.w,r.h,r.saltoNormaleX,r.saltoNormaleY);
                        /*
                        if(numPezzi==numTotalePezzi)
                            System.out.println("vieni eseguito?");//*/
                    }
                }
            }
                            
            score=score+1;
            numPezzi++;
            if(numPezzi==numTotalePezzi)
            {
                //repaint e sleep servono a far vedere l'immagine completa a fine livello
                repaint();
                try
                {
                    Thread.sleep(1000);
                }
                catch(Exception e){}
                cambiaLivello();
            }
        }
    }//testPoint
    
    /**
    * updateInseguitore
    */
    protected void updateInseguitore() {
        if(xAbsPos%InseguitoreConst.MAP_CELL_DIMENSION==0&&yAbsPos%InseguitoreConst.MAP_CELL_DIMENSION==0) {
            xPos=xAbsPos/InseguitoreConst.MAP_CELL_DIMENSION;
            yPos=yAbsPos/InseguitoreConst.MAP_CELL_DIMENSION;

            mosso=false;
            
            if(dirCandidata!=dirReale) {
                switch(dirCandidata)  {
                    case 0:
                        if(mappaCorrente[yPos][xPos-1])
                        {
                            dirReale=dirCandidata;
                            mosso=true;
                        }
                        break;
                    case 1:
                        if(mappaCorrente[yPos][xPos+1])
                        {
                            dirReale=dirCandidata;
                            mosso=true;
                        }
                        break;
                    case 2:
                        if(mappaCorrente[yPos-1][xPos])
                        {
                            dirReale=dirCandidata;
                            mosso=true;
                        }
                        break;
                    case 3:
                        if(mappaCorrente[yPos+1][xPos])
                        {
                            dirReale=dirCandidata;
                            mosso=true;
                        }
                        break;
                }
            }
            
            if(mosso)
            {}
            else
            {
                switch(dirReale)                         
                {
                    case 0:
                        if(mappaCorrente[yPos][xPos-1])
                        {
                            mosso=true;
                        }
                        else
                        {
                            dirReale=4;
                        }
                        break;
                    case 1:
                        if(mappaCorrente[yPos][xPos+1])
                        {
                            mosso=true;
                        }
                        else
                        {
                            dirReale=4;
                        }
                        break;
                    case 2:
                        if(mappaCorrente[yPos-1][xPos])
                        {
                            mosso=true;
                        }
                        else
                        {
                            dirReale=4;
                        }
                        break;
                    case 3:
                        if(mappaCorrente[yPos+1][xPos])
                        {
                            mosso=true;
                        }
                        else
                        {
                            dirReale=4;
                        }
                        break;
                }
            }
        }
        else
        {
            switch(dirCandidata)                         
            {
                case 0:
                    if(dirReale==1)
                    {
                        dirReale=0;
                    }
                    break;
                case 1:
                    if(dirReale==0)
                    {
                        dirReale=1;
                    }
                    break;
                case 2:
                    if(dirReale==3)
                    {
                        dirReale=2;
                    }
                    break;
                case 3:
                    if(dirReale==2)
                    {
                        dirReale=3;
                    }
                    break;
            }
        }            
    }
    
    /**
    * dead
    */
    protected void InseguitoreDead() 
    {
        try
        {
            Thread.sleep(1000);
        }
        catch(Exception e){}
        
        lives--;
        if(lives==0)
        {
            alive = false;   
            t.setInterval(500);
            gameStarted=0;
            vediRecord=false;
            repaint();            
            saveRecord();
            vediRecord=true;
            firstMatch=false;
        }
        else
        {
            iniziaLivelloComuni();
        }        
    }//dead
    
    /**
    * saveRecord
    */
    private void saveRecord() 
    {
        try 
        {
            int port = getCodeBase().getPort();
            if (port == -1)
                port = 80;
            // aperta la porta 80 se non la si  ottenuta con la getPort
            Socket sock = new Socket(getCodeBase().getHost(),port);
            DataInputStream inStream = new DataInputStream(sock.getInputStream());
            DataOutputStream outStream = new DataOutputStream(sock.getOutputStream());
            String uname = replace(username," ","%20");        	
            // lancio la richiesta in modalit GET... si noti che comunque non si vede nulla lato utente
            outStream.writeBytes("GET http://194.153.73.7/cgi-bin/RecordFollower.asp?username="+uname+"&pwd="+pwd+"&score="+score+"&level="+livello+" HTTP/1.0\r\n\r\n");
            // si noti che passo username, password diversa da gioco a gioco e lo score
            // qui di seguito skippo l'intestazione html
            int length = -1;
            String currLine;
            while( (currLine = inStream.readLine()) != null) 
            {
                if (currLine.length() == 0)
                    break;
                if (currLine.toLowerCase().startsWith("content-length:")) 
                {
                    try
                    {
                        length = Integer.valueOf(currLine.substring(15)).intValue();
                    } 
                    catch(Exception ex) {}
                }
            }
            // result conterr il contenuto ritornato
            String result = "";
            while( (currLine = inStream.readLine()) != null)
                result += currLine;
            
            System.out.println(" -->"+result.substring(7)+"\n");
            if (result.startsWith("SAVED:")) 
            {
                // estrae la nuova posizione in classifica
                classPosition = (new Integer(result.substring(7))).intValue();
                saved = true;
            } 
            else
            {
                // no record
                classPosition = -1;
                saved = false;
            }
            
        }
        catch(Exception e) 
        {
            System.out.println("eccezione: " + e + "\n");
        }
    }

    /**
     * replace
     */
    public String replace(String str, String source, String dest) 
    {
        int index = 0;
        int lunghSource = source.length();
        
        while ( (index = str.indexOf(source,index)) != -1) 
        {
            str = str.substring(0,index) + dest + str.substring(index+lunghSource);
            index += dest.length();
        }
        return str;
    }
	    
    /**
    * destroy
    */
    public void destroy() 
    {
        t.stop();
        t = null;
        
        super.destroy();
    }
} // end InseguitoreApplet