/**
 *
 * @author  Ing. Alessandro Campi
 * @version 
 */

public class Nemico
{
    // Nemico
    public int xPosNemico;
    public int yPosNemico;
    int xAbsPosNemico;
    int yAbsPosNemico;
    int xIniziale=37;
    int yIniziale=37;
    int dirDaProvare=1;
    boolean soddisfatta;
    
    boolean liberoDestra;
    boolean liberoSinistra;
    boolean liberoSopra;
    boolean liberoSotto;
    
    private static final int passo=InseguitoreConst.PASSO;

    // nemico direction   0 = sx    1 = dx      2 = up    3 = down
    int dirCandidataNemico = 1;
    int dirRealeNemico = 1;
    
    int distanzaContatto=InseguitoreConst.DISTANZA_CONTATTO;
    
    //giro da un po' di casualit alla caccia
    int giro=0;  


    /** Creates new nemico */
    
    public Nemico()
    {}
    
    public Nemico(int xIniz,int yIniz) 
    {
        xIniziale=xIniz;
        yIniziale=yIniz;
        giro=yIniz;
    }
        
    /*
     *inizializzaPosizioneNemico
     */
    public void inizializzaPosizioneNemico()
    {
        xPosNemico=xIniziale;
        yPosNemico=yIniziale;
        xAbsPosNemico=xPosNemico*InseguitoreConst.MAP_CELL_DIMENSION;
        yAbsPosNemico=yPosNemico*InseguitoreConst.MAP_CELL_DIMENSION;
        dirCandidataNemico=0;
        dirRealeNemico=0;
    }//inizializzaPosizioneInseguitore
    
    /**
    * muoviNemico
    */
    public void muoviNemico()
    {
        switch(dirRealeNemico)                         
        {
            case 0: xAbsPosNemico-=passo; break;
            case 1: xAbsPosNemico+=passo; break;
            case 2: yAbsPosNemico-=passo; break;
            case 3: yAbsPosNemico+=passo; break;
        }
    }//muoviNemico    


    /**
    * updateNemico
    */
    public void updateNemico(boolean mappaCorrente[][],int xAbsPosition,int yAbsPosition,
    		int dirCandidata)
    {
        //selezione dirCandidataNemico

        if(xAbsPosNemico%InseguitoreConst.MAP_CELL_DIMENSION==0 &&
        		yAbsPosNemico%InseguitoreConst.MAP_CELL_DIMENSION==0)
        {
            int xp=xAbsPosNemico/InseguitoreConst.MAP_CELL_DIMENSION;
            int yp=yAbsPosNemico/InseguitoreConst.MAP_CELL_DIMENSION;
            
            //booleani prcalcolati perch usati spesso
            liberoDestra=mappaCorrente[yp][xp+1];
            liberoSinistra=mappaCorrente[yp][xp-1];
            liberoSopra=mappaCorrente[yp-1][xp];
            liberoSotto=mappaCorrente[yp+1][xp];

            //scelta nuovaDIR DA FARE
            int nuovaDir=0;
            nuovaDir = calcolaDirezioneNemico(xAbsPosition,yAbsPosition,dirCandidata);

            boolean ok=false;
            
            boolean provati[]={false,false,false,false};
            
            //serva ad evitare che faccia avanti indietro
            switch(dirRealeNemico) {
                case 0: provati[1]=true;  break;
                case 1: provati[0]=true;  break;
                case 2: provati[3]=true;  break;
                case 3: provati[2]=true;  break;
            }            
                        
            while(!ok) {
                if(soddisfatta) {
                    soddisfatta=false;
                } else {
                    while(provati[nuovaDir])
                    {
                        nuovaDir++;
                        if(nuovaDir==4)
                            nuovaDir=0;
                    }
                }
                
                provati[nuovaDir]=true;
                
                switch(nuovaDir) {
                    case 0:
                        if(liberoSinistra) {
                            ok=true;
                        }
                        break;
                    case 1:
                        if(liberoDestra) {
                            ok=true;
                        }
                        break;
                    case 2:
                        if(liberoSopra) {
                            ok=true;
                        }
                        break;
                    case 3:
                        if(liberoSotto) {
                            ok=true;
                        }
                        break;
                }
                
                //codice per i cunicoli chiusi
                if(provati[0]&&provati[1]&&provati[2]&&provati[3])
                {
                    provati[0]=false;
                    provati[1]=false;
                    provati[2]=false;
                    provati[3]=false;
                }
            }
            
            dirRealeNemico=nuovaDir;
            
            soddisfatta=(dirRealeNemico==dirDaProvare);
        }            
    }//updateNemico
    
    /*
     *calcolaDirezioneNemico
     */
    private final int calcolaDirezioneNemico(int xAbsPos,int yAbsPos,int dirCandidata) {
        if(giro>=100) {
            giro=0;
                
            switch(dirRealeNemico) {
                case 0:
                    if(liberoDestra) {
                        soddisfatta=true;
                        return 1;
                    }
                    break;
                case 1:
                    if(liberoSinistra) {
                        soddisfatta=true;
                        return 0;
                    }
                    break;
                case 2:
                    if(liberoSopra) {
                        soddisfatta=true;
                        return 3;
                    }
                    break;
                case 3:
                    if(liberoSotto) {
                        soddisfatta=true;
                        return 2;
                    }
                    break;            
            }
        }
        else
            giro++;
        
        try {
            float dx=xAbsPosNemico-xAbsPos;
            float m=(yAbsPos-yAbsPosNemico)/dx;
            //System.out.println("m="+m);
            if(dx<0) {
                if(m>1) {
                    // inseguitore direction   0 = sx    1 = dx      2 = up    3 = down
                    return 2;
                } else if(m<-1) {
                    return 3;
                } else {
                    return 1;
                }
            } else {
                if(m>1) {
                    // inseguitore direction   0 = sx    1 = dx      2 = up    3 = down
                    return 3;
                } else if(m<-1) {
                    return 2;
                } else {
                    return 0;
                }
            }
        }
        catch(ArithmeticException Ae) { return dirCandidata; }
    }//calcolaDirezioneNemico
    
    /**
    * checkNemico
    */
    public boolean checkNemico(int xAbsPos,int yAbsPos) 
    {        
        int dx=xAbsPos-xAbsPosNemico;
        int dy=yAbsPos-yAbsPosNemico;

        return ((dx*dx+dy*dy)<distanzaContatto);
    }
}
