/**
 * it.MediaIllusion.Utils
 * Class containing static utility methods
 * Author: Ignazio Locatelli - Media Illusion - (C) 2000
 */

package it.MediaIllusion.Utils;

import java.io.*;

public class Utils {

  /**
   * readFile
   */
  public static String readFile(String file) {
    String str = new String("");
    char buf[] = new char[8192];
    try {
      FileReader fin = new FileReader(file);
      while(fin.read(buf) != -1)
        str += new String(buf);
    } catch(Exception e) {
      str = "Eccezione rilevata: " + e + "<br>";
    }
    return str;
  }

  /**
   * replace
   */
  public static String replace(String str, String source, String dest) {
    int index = 0;
    int lunghSource = source.length();

    while ( (index = str.indexOf(source,index)) != -1) {
      str = str.substring(0,index) + dest + str.substring(index+lunghSource);
    	index += dest.length();
    }
    return str;
  }
	
  /**
   * getYear: from a date (source format indicated by flag)
   */
  public static int getYear(String date, int flag) {       
    try {
      if (flag == 0)
        return Integer.parseInt(date.substring(0,4));
      else
        return 0;
    } catch(Exception e) {}
    return 0;
  }
	
  /**
   * getMonth: from a date (source format indicated by flag)
   */
  public static int getMonth(String date, int flag) {
    try {
      if (flag == 0)
        return Integer.parseInt(date.substring(5,7));        
      else
        return 0;
    } catch (Exception e) {}
    return 0;
  }
	
  /**
   * getDay: from a date (source format indicated by flag)         
   */
  public static int getDay(String date, int flag) {
    try {
      if (flag == 0)
        return Integer.parseInt(date.substring(8,10)); 
      else
        return 0;
    } catch(Exception e) {}
    return 0;
  }
	
  /**
   * getHour: from a date (source format indicated by flag)
   */
  public static int getHour(String date, int flag) {
    try {
      if (flag == 0)
        return Integer.parseInt(date.substring(11,13));
      else
        return 0;
    } catch(Exception e) {}
    return 0;
  }

  /**
   * getMinutes: from a date (source format indicated by flag)
   */
  public static int getMinutes(String date, int flag) {
    try {
      if (flag == 0)
        return Integer.parseInt(date.substring(14,16));
      else
        return 0;                
    } catch (Exception e) {}
    return 0;
  }
	
  /**
   * formatDate
   */
  public static String formatDate(String date, int flag) {
    String strHour;
    String strMin;
    int h = Utils.getHour(date,0);
    if (h < 10)
      strHour = "0"+h;
    else
      strHour = "" + h;
    int m = Utils.getMinutes(date,0);
    if (m < 10)
      strMin = "0"+m;
    else
      strMin = ""+m;
    if (flag == 0)
      return Utils.getDay(date,0)+"-"+Utils.getMonth(date,0)+"-"+Utils.getYear(date,0)+" "+strHour+":"+strMin;
    if (flag == 1)
      return Utils.getDay(date,0)+"-"+Utils.getMonth(date,0)+"-"+Utils.getYear(date,0);
		
    // default
    return Utils.getDay(date,0)+"-"+Utils.getMonth(date,0)+"-"+Utils.getYear(date,0)+" "+strHour+":"+strMin;         
  }
}
